{--------------------------------------------------------}
{
{    Mdulo para atualizar Youtube-dl, Tocadores e Voxtube
{
{    Autor: Glauco Frius
{
{    Em Setembro de 2017
{
{--------------------------------------------------------}

Unit vtAtualiza;

interface

uses
    Windows,
    dvcrt,
    dvwin,
    dvForm,
    dvinet,
    dvSapGlb,
    vtmsg,
    SysUtils,
    dvexec,
    shellApi;

procedure atualizaYoutubedl;
procedure instalaTocadores;
procedure atualizaVoxtube;

implementation

var
    comEfeitos: boolean;
    meuNome: array [0..101] of char;

{-------------------------------------------------------------}
{                       executa um programa
{-------------------------------------------------------------}

function executaProg (nomeProg, nomeDir, nomeArq: string): boolean;
var
    pprog, pdir, pparam: array [0..100] of char;
    erro: tHandle;
    s: string;

begin
    executaProg := true;
    strPcopy (pprog, nomeProg);
    strPCopy (pdir, nomeDir);
    strPcopy (pparam, nomeArq);

    GetWindowText(crtWindow, meuNome, 100);

    erro := ShellExecute(crtWindow, 'open', pprog, pparam, pdir, SW_SHOWNORMAL);
    if erro < 32 then
        begin
            textBackground (RED);
            mensagem ('VTNAOEXE', 0);  {'No foi possvel executar esse programa, erro  #'}
            sintWriteInt (erro);
            textBackground (RED);
            writeln;
            executaProg := false;
        end;

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
    begin
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) = 'N';
    end
    else
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) <> 'N';
        if comEfeitos then
begin
  comEfeitos :=true;
end;

end;

{--------------------------------------------------------}

procedure atualizaYoutubedl;
var
    nomeProg: string;
    salvaDir, dirExecVoxtube: string;
begin
                mensagem ('VTVERATU', 1);   {'Verificando atualizao do Youtube-dl'}
        getDir (0, salvaDir);
    dirExecVoxtube := (sintambiente('DOSVOX','PGMDOSVOX'));
    chdir (dirExecVoxtube);
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\wget');
            if executaProg(nomeProg, '', '-N --unlink http://yt-dl.org/downloads/latest/youtube-dl.exe') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTVTJAATUA', 1);   {'Youtube-dl j est atualizado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
                end;

{--------------------------------------------------------}

procedure instalaTocadores;
var
    nomeProg, nome: string;
    salvaDir, dirExecVoxtube: string;
    arqOut: file;
    i1, i2, i3, i4, i5, i6, i7: integer;
begin

    i1 := 0;
    i2 := 0;
    i3 := 0;
    i4 := 0;
    i5 := 0;
    i6 := 0;
    i7 := 0;
                mensagem ('VTVERTOC', 1);   {'Verificando instalao dos tocadores'}
        getDir (0, salvaDir);
    dirExecVoxtube  := sintambiente('DOSVOX','PGMDOSVOX');
    chdir (dirExecVoxtube);
begin
nome := (dirExecVoxtube + '\' + 'ffplay.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i1:= 1
    else
    begin
                mensagem ('VTBAIPRI', 1);   {'Instalando o tocador 1 - ffplay'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador1.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC1INS', 1);   {'Tocador 1 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'mpc-hc\mpc-hc.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i2:= 1
    else
    begin
                mensagem ('VTBAISEG', 1);   {'Instalando o tocador 2 - mpc-hc'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador2.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC2INS', 1);   {'Tocador 2 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'potplayerportable\PotPlayerPortable.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i3:= 1
    else
    begin
                mensagem ('VTBAITER', 1);   {'Instalando o tocador 3 - PotPlayerPortable'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador3.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC3INS', 1);   {'Tocador 3 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'vlc\vlc.exe ');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i4:= 1
    else
    begin
                mensagem ('VTBAIQUA', 1);   {'Instalando o tocador 4 - VLC'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador4.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC4INS', 1);   {'Tocador 4 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'kmplayer\KMPlayer.exe ');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i5:= 1
    else
    begin
                mensagem ('VTBAIQUI', 1);   {'Instalando o tocador 5 - KMPlayer'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador5.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC5INS', 1);   {'Tocador 5 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'mpc-be\mpc-be.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i6:= 1
    else
    begin
                mensagem ('VTBAISEX', 1);   {'Instalando o tocador 6 - mpc-be'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador6.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC6INS', 1);   {'Tocador 6 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'gomplayer\GOM.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i7:= 1
    else
    begin
                mensagem ('VTBAISET', 1);   {'Instalando o tocador 7 - GOMPlayer'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador7.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC7INS', 1);   {'Tocador 7 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
    if (i3 = 0) or (i4 = 0) or (i5 = 0) or (i6 = 0) or (i7 = 0) then
    begin
                mensagem ('VTTOCINS', 1)   {'Os tocadores esto instalados'}
end
    else
    begin
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOCINS', 1);   {'Tocadores j esto instalados'}
end;
end;

{--------------------------------------------------------}

procedure atualizaVoxtube;
var
    nome, nomeProg: string;
    salvaDir, dirExecVoxtube: string;
    arqOut: file;
    busca : string;
     textoAProcurar: string;

begin

                mensagem ('VTVATUAL', 1);   {'Verificando atualizao do Voxtube'}
        getDir (0, salvaDir);
    dirExecVoxtube := (sintambiente('DOSVOX','PGMDOSVOX'));
    chdir (dirExecVoxtube);
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\atualiza');
                    begin
            if executaProg(nomeProg, '', '') then
                    esperaProgVoltar;
            if comEfeitos = true then
            begin
    sintsom ('msn_switching');
                mensagem ('VTATUALIZADO', 1);   {'Voxtube tambm j est atualizado'}
            end
            else
                mensagem ('VTATUALIZADO', 1);   {'Voxtube tambm j est atualizado'}
                mensagem ('VTVERFFM', 1);   {'Verificando instalao do ffmpeg'}
nome := (dirExecVoxtube  + '\' + 'ffmpeg.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult <> 0 then
    begin
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTINSFFM', 1);   {'Instalando o ffmpeg'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\atuffmpeg');
            if executaProg(nomeProg, '', '') then
                    esperaProgVoltar;
                    end;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTFFMINS', 1);   {'ffmpeg j est instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
instalaTocadores;
                end;

    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
    busca := textoAProcurar;
        mensagem ('VTDIGBUS', 0);  {'Digite sua busca, ou use as setas para folhear a memria'}
    sintetiza (busca);
                end;

{--------------------------------------------------------}

end.
