{--------------------------------------------------------}

{
{    VoxTube - utilitrio de acessibilizao do YouTube
{
{    Procedimentos de download
{
{    Autor:  Fabiano Ferreira
{
{    Em fevereiro de 2013
{
{--------------------------------------------------------}
unit vtRede;

interface
uses
 dvcrt,
 dvwin,
 dvinet,
 vtmsg,
 sysutils;

function stringToURL(s: string): string;
function URLToString(s: string): string;
function download(link, nomeArq: string; comclek : boolean; cookies : string) : boolean;

implementation

{--------------------------------------------------------}
{   transforma string para a codificao usada em URLs
{--------------------------------------------------------}

function stringToURL(s: string): string;
var i: integer;
begin
    result := '';
    for i := 1 to length(s) do
        begin
            if s[i] in ['0'..'9', 'a'..'z', 'A'..'Z', '.', '-', '_', '~'] then
                result := result + s[i]
            else
                result := result + '%' + intToHex(ord(s[i]), 2);
        end;
end;

{--------------------------------------------------------}
{   transforma string para a codificao usada em URLs
{--------------------------------------------------------}

function URLToString(s: string): string;

    function hex(c: char): integer;
    begin
        if c in ['0'..'9'] then result := ord(c) - ord('0')
        else
        if c in ['a'..'f'] then result := ord(c) - ord('a') + 10
        else
        if c in ['A'..'F'] then result := ord(c) - ord('A') + 10
        else
            result := 0;
    end;

var i, n: integer;

begin
    result := '';
    i := 1;
    while i <= length(s) do
        begin
            if (s[i] = '%') and (i <= length(s)-2) then
                begin
                    n := (hex(s[i+1]) shl 4) + hex(s[i+1]);
                    result := result + chr(n);
                    i := i + 3;
                end
            else
                begin
                    result := result + s[i];
                    i := i + 1;
                end;
        end;
end;

{--------------------------------------------------------}
{   faz download do vdeo
{--------------------------------------------------------}

function download(link, nomeArq: string; comclek : boolean; cookies : string) : boolean;

procedure trazhtml(link, nomeArq: string; comclek : boolean; cookies : string);
var buf : pbufrede;
sock : integer;
s : string;
arq : text;
host: string;
comssl : boolean;
i, j : integer;
porta : string;

Begin
if uppercase(copy (link,1,5)) = 'HTTPS' then comssl := true
else
comssl := false;
    if (link = '') or (nomearq = '') then exit;
assignfile(arq,nomearq);
    link := copy (link, pos('://', link)+3, 999);
    i := pos (':', link);
if i <> 0 then begin
i := i + 1;
j := length(link);
porta := copy (link, i,j-i+1);
i := pos('/',porta);
if i <> 0 then
porta := copy (porta, 1,i-1);
link := stringreplace(link,':'+porta,'',[rfreplaceall]);
end;

    i := pos ('/', link);
if i = 0 then begin
    host := link;
link := '/';
host := copy (link, 1, i-1);
end
else
begin
    host := copy (link, 1, i-1);
    delete (link, 1, i-1);
end;

abrewinsock;
if (porta = '') and (not comssl) then
porta := '80'
else
if (porta = '') and (comssl) then
porta := '443';
sock := abreconexao (host,strtoint(porta));
buf := inicbufrede(sock);
writelnrede(sock,'GET '+link+' HTTP/1.1');
writelnrede(sock,'Host: '+host);
writelnrede(sock,'User-Agent: dosvox');
writelnrede(sock,'Connection: close');
writelnrede(sock,'Accept-Language: pt-br');
writelnrede(sock,'UA-CPU: x86');
if cookies <> '' then
    writelnRede(sock,'Cookie: '+cookies);
writelnrede(sock,'');

repeat
readlnbufrede(buf,s,0);
until (s = '');

rewrite(arq);
while (readlnbufrede(buf,s,0)) do writeln(arq,s);
 writeln(arq,s);
fechaconexao(sock);
fechawinsock;
fimbufrede(buf);
closefile(arq);
end;
{
function obtemtaxatransf(rtaxatransf : extended; ccc, ccc2 : word) : string;
var s : string;
begin
if ccc2 < ccc then ccc2 := ccc2 + 100;
if ccc2 = ccc then exit;
ccc2 := ccc2-ccc;
rtaxatransf := rtaxatransf / 1024.0;
rtaxatransf := (100*rtaxatransf / ccc2)*8;
if rtaxatransf >= 1024 then
begin
rtaxatransf := rtaxatransf / 1024.0;
s := floattostrf(rtaxatransf,ffgeneral,5,2) + 'Mb/s';
end
else
s := floattostrf(rtaxatransf,ffgeneral,5,2) + 'Kb/s';
if pos ('E',s) > 0 then
s := copy(s,1,pos('E',s)-1);
obtemtaxatransf := s;
end;
}
const
    UM_K = 1024;
um_m = 1024*1024;
um_g= 1024*1024*1024;
erro_400= 'Erro http400:Requisio http no foi bem formulada.';
    Erro_404 ='Erro http404: Pgina no encontrada.';
dl_resumido='Retomando download';
bytesaTransferir  = 51200;
var
    sock : integer;
    buflocal : array[1..bytesaTransferir ] of char;
    buf : pbufrede;
    host : string;
original : string;

    arq : file;
escritos, areceber, aTransferir, tamanho : int64;
recebidos : extended;
srecebidos : string;
porcentagem : extended;
sporcentagem : string;
transferidos : integer;
    s: string;
    i, j: longint;
    c, c2 : char;
jagravados : int64;
    status: string;
comssl : boolean;
porta : string;
tipo : string;
gravandoaudio : boolean;
label montacabec, fim, fimRede;

begin
original := link;
    download := false;
    jagravados := 0;

    if (link = '') or (nomearq = '') then exit;
    assignfile(arq, nomearq);
montaCabec:
if uppercase(copy (link,1,5)) = 'HTTPS' then comssl := true
else
comssl := false;

    link := copy (link, pos('://', link)+3, 999);
    i := pos (':', link);
if i <> 0 then begin
i := i + 1;
j := length(link);
porta := copy (link, i,j-i+1);
i := pos('/',porta);
if i <> 0 then
porta := copy (porta, 1,i-1);
link := stringreplace(link,':'+porta,'',[rfreplaceall]);
end;

    i := pos ('/', link);
if i = 0 then begin
    host := link;
link := '/';
end
else
begin
    host := copy (link, 1, i-1);
    delete (link, 1, i-1);
end;
    abreWinsock;
if (porta = '') and (not comssl) then
porta := '80'
else
if (porta = '') and (comssl) then
porta := '443';
if comssl then
sock := abreconexaossl (host,strtoint(porta))
else
sock := abreconexao (host,strtoint(porta));

    writelnRede(sock,'GET '+ link +' HTTP/1.1');
writelnrede(sock,'User-Agent: scripvox+ V5.x');
writelnrede(sock,'Accept: */*');
    writelnRede(sock,'Host: '+host);
writelnrede(sock,'Connection: close');
    if fileexists (nomearq) then
begin
filemode := 2;
reset(arq, 1);

        jagravados := int64( filesize(arq));
if jagravados < 0 then jagravados := jagravados*-1;
    Writelnrede (sock,'Range: bytes='+inttostr(jagravados)+'-');
end;

if cookies <> '' then
    writelnRede(sock,'Cookie: '+cookies);

    writelnRede(sock,'');

    buf := inicBufRede(sock);
    readlnBufRede(buf, s, 0);

    status := copy (s, pos(' ', s) + 1, 3);
    case strtoint(status) of
        400: begin
                mensagem ('VT_E400', 1);   {'Erro http400: Requisio http no foi bem formulada.'}
                exit;
             end;
        404: begin
                mensagem ('VT_E404', 1);   {'Erro http404: Pgina no encontrada.'}
                exit;
             end;
        206: mensagem ('VTRETOMA', 1);     {'Retomando download'}

        200: begin
                {$I-} rewrite (arq, 1); {$I+}
                if ioresult <> 0 then
                    begin
                        mensagem ('VTERRCRI', 1); {'Erro na criao do arquivo.  Verifique o nome e espao em disco.'}
                        goto fimRede;
                    end;
             end;
    end;

    tamanho := 0;
    repeat
        readlnBufRede(buf, s, 0);
        if copy(s, 1, 8) = 'Location' then
            begin
                link :=  copy(s, 11, length(s));
                fimBufRede(buf);
                fechaConexao(sock);
                fechaWinsock;
original := link;
                goto montaCabec;
            end;
        if uppercase (copy(s, 1, 12)) = 'CONTENT-TYPE' then
tipo := trim(copy(s, 14, length(s)));

        if uppercase (copy(s, 1, 14)) = 'CONTENT-LENGTH' then begin
s := copy(s, 16,999999);
            tamanho := strtoint64(s);
end;
    until s = '';

    if jagravados > 0 then seek(arq,jagravados);

    if jagravados > 0 then
begin
    transferidos := jagravados;
end
    else

if tamanho = 0 then begin
 tamanho := 999999999;
gravandoaudio := true;
end;
    aReceber := tamanho;

    while (aReceber >= 1) or (true)do
        begin
if areceber >= bytesaTransferir  then
aTransferir  := bytesaTransferir
else
                aTransferir := aReceber;

//gettime (hh,mm,ss,ccc);
            for i := 1 to aTransferir  do
                lecaracbufrede(buf,buflocal[i]);
//gettime (hh,mm,ss,ccc2);
            {$I-}
            blockwrite(arq, buflocal, aTransferir, transferidos);
            {$I+}
            if (ioresult <> 0) or (transferidos <> aTransferir) then
                begin
                    mensagem ('VTERRGRV', 1); {'Erro de gravao. Verifique o espao em disco.'}
                    goto fim;
                end;

if transferidos = 0 then goto fim;
if not gravandoaudio then             aReceber := aReceber - aTransferir ;
//rtaxatransf := transferidos;
if comclek then sintclek;
//taxatransf := obtemtaxatransf(rtaxatransf,ccc,ccc2);

if keypressed then
                begin
                    c := readkey;
                    if c = #13 then
                        Begin
            escritos := int64(filesize(arq));
recebidos := int64(filesize(arq));
if recebidos <0 then recebidos := recebidos *-1;
if gravandoaudio then
begin
sintWriteLn (inttostr(filesize(arq))+' bytes ');
                        mensagem ('VTESCRDK', 1);  {' escritos em disco'}
end
else
begin
                        mensagem ('VTRECEBI', 1);  {'Recebidos: '}
                            porcentagem := escritos /(tamanho+jagravados)  * 100;
sporcentagem := floattostrf(porcentagem,ffgeneral,3,2);
if pos ('E',sporcentagem) > 0 then
sporcentagem := copy(sporcentagem,1,pos('E',sporcentagem)-1);

    if tamanho+jagravados >= um_g then
begin
sintWriteLn (sporcentagem+'%');
            mensagem ('VTDE', 1); {' de '}
sintWriteLn  (inttostr ((tamanho+jagravados) div um_g));
                        mensagem ('VTGB', 1);  {' Gigabytes'}
end
else
    if tamanho+jagravados >= um_m then
begin
sintWriteLn (sporcentagem+'%');
            mensagem ('VTDE', 1); {' de '}
sintWriteLn (inttostr ((tamanho+jagravados) div um_M));
                        mensagem ('VTMB', 1);  {' Megabytes'}
end
    else
    if tamanho+jagravados >= um_k then
begin
sintWriteLn (sporcentagem+'%');
            mensagem ('VTDE', 1); {' de '}
sintWriteLn (inttostr ((tamanho+jagravados) div um_k));
                        mensagem ('VTKB', 1);  {' Kbytes'}
end
else
begin
sintWriteLn (sporcentagem+'%');
            mensagem ('VTDE', 1); {' de '}
sintWriteLn (inttostr ((tamanho+jagravados)));
            mensagem ('VTBYTES', 1); {' Bytes'}
end;
end;

if recebidos >= um_g then
begin
recebidos := recebidos / um_g;
srecebidos := floattostrf(recebidos,ffgeneral,3,2);
                        mensagem ('VTOU', 1);  {' ou '}
sintWriteLn (srecebidos);
                        mensagem ('VTGB', 1);  {' Gigabytes'}
                        mensagem ('VTESCRDK', 1);  {' escritos em disco'}
end
else
if recebidos >= um_m then
begin
recebidos := recebidos / um_m;
srecebidos := floattostrf(recebidos,ffgeneral,3,2);
                        mensagem ('VTOU', 1);  {' ou '}
sintWriteLn (srecebidos);
                        mensagem ('VTMB', 1);  {' Megabytes'}
                        mensagem ('VTESCRDK', 1);  {' escritos em disco'}
end
else
if recebidos >= um_k then
begin
recebidos := recebidos / um_k;
srecebidos := floattostrf(recebidos,ffgeneral,3,2);
                        mensagem ('VTOU', 1);  {' ou '}
sintWriteLn (srecebidos);
                        mensagem ('VTKB', 1);  {' Kbytes'}
                        mensagem ('VTESCRDK', 1);  {' escritos em disco'}
end
else
begin
srecebidos := floattostrf(recebidos,ffgeneral,3,2);
                        mensagem ('VTOU', 1);  {' ou '}
sintWriteLn (srecebidos);
                        mensagem ('VTBYTES', 1);  {' Bytes'}
                        mensagem ('VTESCRDK', 1);  {' escritos em disco'}
end;
                        mensagem ('VTARQUIV', 1);  {' Arquivo: '}
sintWriteLn (nomearq);
sintWriteLn ('');
//sintWriteLn ('Taxa de transferncia: ');
//sintWriteLn (taxatransf+' KBPS');
                        end
                    else
                    if c = #32 then
                        comclek := not comClek
                    else
                    if c = ESC then
                        begin
            mensagem('VTDESPDL', 1); {'Deseja parar o download?'}
                            c2 := sintreadkey;
                            writeln(c2);
    if (upcase(c2) = 'S') or (upcase(c2) = ESC) then
begin
            mensagem('VTDLINTR', 1); {'O download foi interrompido.'}
 goto fim;
end;
                        end;
                end;
        end;
fim:
    {$I-}
    closefile(arq);
    {$I+}
    if ioresult <> 0 then;  // j mostrou erro antes

fimRede:
    fimbufrede(buf);
    fechaconexao(sock);
    fechawinsock;
    if (areceber <= 1) or (gravandoaudio)then download := true;
end;

end.
